# coding: utf-8

"""
    FINBOURNE Identity Service API

    FINBOURNE Technology  # noqa: E501

    Contact: info@finbourne.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, Dict, Optional
from pydantic import BaseModel, Field, StrictBool, StrictInt

class PasswordPolicyComplexity(BaseModel):
    """
    PasswordPolicyComplexity
    """
    min_length: Optional[StrictInt] = Field(None, alias="minLength", description="The minimum length for a password")
    exclude_first_name: Optional[StrictBool] = Field(None, alias="excludeFirstName", description="Rule determining whether a user's first name should be permitted in their password")
    exclude_last_name: Optional[StrictBool] = Field(None, alias="excludeLastName", description="Rule determining whether a user's last name should be permitted in their password")
    __properties = ["minLength", "excludeFirstName", "excludeLastName"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PasswordPolicyComplexity:
        """Create an instance of PasswordPolicyComplexity from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PasswordPolicyComplexity:
        """Create an instance of PasswordPolicyComplexity from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PasswordPolicyComplexity.parse_obj(obj)

        _obj = PasswordPolicyComplexity.parse_obj({
            "min_length": obj.get("minLength"),
            "exclude_first_name": obj.get("excludeFirstName"),
            "exclude_last_name": obj.get("excludeLastName")
        })
        return _obj
